<!doctype html>
<html>

<head>
  <meta name="generator" content="JSDoc 3.6.3">
  <meta charset="utf-8">
  <title>Source: components/video/index.js</title>
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Karla:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Noto+Serif:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Inconsolata:500" type="text/css">
  <link href="css/baseline.css" rel="stylesheet">
</head>

<body onload="prettyPrint()">
  <nav id="jsdoc-navbar" role="navigation" class="jsdoc-navbar">
    <div id="jsdoc-navbar-container">
      <div id="jsdoc-navbar-content">
        <a href="index.html" class="jsdoc-navbar-package-name">Home</a>
      </div>
    </div>
  </nav>
  <div id="jsdoc-body-container">
    <div id="jsdoc-content">
      <div id="jsdoc-content-container">
        <div id="jsdoc-banner" role="banner">
        </div>
        <div id="jsdoc-main" role="main">
          <header class="page-header">
            <h1>Source: components/video/index.js</h1>
          </header>
          <article>
            <pre class="prettyprint linenums"><code>import style from &#x27;./style.scss&#x27;
import { h, Component } from &#x27;preact&#x27;

let classNames &#x3D; (require(&#x27;classnames/bind&#x27;)).bind(style)

/**
 * podstawowy komponent video html5
 *
 * @export
 * @class Video
 * @extends {Component}
 */
export default class Video extends Component {
  constructor (props, state) {
    super(props, state)

    /**
      * referencja do node video; umożliwiająca korzystanie z natywnych właściwości
      * @type {Node}
      */
    this.video &#x3D; null

    this.state.percentile &#x3D; 0
    this.state.quartile &#x3D; 0
    this.state.seconds &#x3D; 0
    this.state.muted &#x3D; this.props.muted || this.props.autoplay || false

    if (!(&#x27;gui&#x27; in this.props)) this.props.gui &#x3D; []

    /**
      * vast może być zarówno pojedynczym obiektem, jak i tablicą z obiektami
      * poniższy kod ma na celu ujednolicenie postaci do tablicy
      */
    if (&#x27;vast&#x27; in this.props &amp;amp;&amp;amp; typeof this.props.vast &#x3D;&#x3D;&#x3D; &#x27;object&#x27;) {
      if (this.props.vast instanceof Array) {
        this.props.vast &#x3D; this.props.vast
      } else {
        this.props.vast &#x3D; [this.props.vast]
      }
    } else {
      this.props.vast &#x3D; []
    }

    this.onInit &#x3D; this.onInit.bind(this)
    this.onPlay &#x3D; this.onPlay.bind(this)
    this.onClick &#x3D; this.onClick.bind(this)
    this.onPause &#x3D; this.onPause.bind(this)
    this.onStop &#x3D; this.onStop.bind(this)
    this.onLoadedData &#x3D; this.onLoadedData.bind(this)
    this.onEnded &#x3D; this.onEnded.bind(this)
    this.onTimeUpdate &#x3D; this.onTimeUpdate.bind(this)
    this.onWaiting &#x3D; this.onWaiting.bind(this)
    this.onQuartileChange &#x3D; this.onQuartileChange.bind(this)
    this.onFullSecondChange &#x3D; this.onFullSecondChange.bind(this)
    this.onVastEvent &#x3D; this.onVastEvent.bind(this)

    this.toggle &#x3D; this.toggle.bind(this)
    this.play &#x3D; this.play.bind(this)
    this.pause &#x3D; this.pause.bind(this)
    this.toggleVolume &#x3D; this.toggleVolume.bind(this)
    this.toggleFullScreen &#x3D; this.toggleFullScreen.bind(this)

    if (typeof this.props.onPlay &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onPlay &#x3D; this.props.onPlay.bind(this)
    if (typeof this.props.onClick &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onClick &#x3D; this.props.onClick.bind(this)
    if (typeof this.props.onPause &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onPause &#x3D; this.props.onPause.bind(this)
    if (typeof this.props.onStop &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onStop &#x3D; this.props.onStop.bind(this)
    if (typeof this.props.onReady &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onReady &#x3D; this.props.onReady.bind(this)
    if (typeof this.props.onEnded &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onEnded &#x3D; this.props.onEnded.bind(this)
    if (typeof this.props.onTimeUpdate &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onTimeUpdate &#x3D; this.props.onTimeUpdate.bind(this)
    if (typeof this.props.onWaiting &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onWaiting &#x3D; this.props.onWaiting.bind(this)
    if (typeof this.props.onQuartileChange &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onQuartileChange &#x3D; this.props.onQuartileChange.bind(this)
    if (typeof this.props.onFullSecondChange &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onFullSecondChange &#x3D; this.props.onFullSecondChange.bind(this)
    if (typeof this.props.onVastEvent &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onVastEvent &#x3D; this.props.onVastEvent.bind(this)

    this.onInit()
  }

  /**
    * callback na zakończenie działania constructora
    * @memberof Video
    */
  onInit () {}

  onPlay () {
    this.setState({ status: &#x27;playing&#x27; })
    this.onVastEvent((this.state.percentile &#x3D;&#x3D;&#x3D; 0) ? &#x27;start&#x27; : &#x27;resume&#x27;)
    if (typeof this.props.onPlay &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onPlay()
  }

  /**
    * zakończenie odtwarzania video również wywołuje event pause
    * by uniknąć błędów dodany jest dodatkowy warunek wywołania kodu funkcji
    * @memberof Video
    */
  onPause () {
    if (this.state.percentile &amp;lt; 100) {
      this.setState({ status: &#x27;paused&#x27; })
      this.onVastEvent(&#x27;pause&#x27;)
      if (typeof this.props.onPause &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onPause()
    }
  }

  onStop () {
    this.setState({ status: &#x27;stopped&#x27; })
    if (typeof this.props.onStop &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onStop()
  }

  /**
    * wywołuje props.onReady(), jeżeli załadowana została wystarczająca ilość danych video
    * @memberof Video
    */
  onLoadedData () {
    if (typeof this.props.onReady &#x3D;&#x3D;&#x3D; &#x27;function&#x27; &amp;amp;&amp;amp; this.video.readyState &gt;&#x3D; 2) this.props.onReady()
  }

  onEnded () {
    this.setState({ status: &#x27;completed&#x27; })
    this.onVastEvent(&#x27;complete&#x27;)
    if (typeof this.props.onEnded &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onEnded()
  }

  onTimeUpdate () {
    /**
      * procent odtworzenia video
      * @type {number}
      * @memberof Video
      */
    let percentile &#x3D; Math.floor((this.video.currentTime / this.video.duration) * 100) / 100

    /**
      * numer ćwiartki video przed bieżącymi obliczeniami, wykorzystywany do weryfikacji, czy nastąpiła zmiana ćwiartki
      */
    let currentQuartile &#x3D; this.state.quartile

    /**
      * sekunda odtwarzania przed bieżącymi obliczeniami, wykorzystywana do weryfikacji, czy nastąpiła zmiana pełnej sekundy odtwarzania video
      */
    let currentTime &#x3D; this.state.seconds

    this.setState({ percentile: percentile })
    this.setState({ seconds: Math.round(this.video.currentTime) })
    this.setState({ quartile: Math.floor(percentile * 4) })

    if (currentQuartile !&#x3D;&#x3D; this.state.quartile) this.onQuartileChange()
    if (currentTime !&#x3D;&#x3D; this.state.seconds) this.onFullSecondChange()

    if (typeof this.props.onTimeUpdate &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onTimeUpdate()
  }

  onWaiting () {
    this.setState({ status: &#x27;waiting&#x27; })
    if (typeof this.props.onWaiting &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onWaiting()
  }

  /**
    * zmiana ćwiartki czasu odtwarzanego video
    * VAST określa zdarzenie zaraportowania odtworzenia pełnych 25% czasu odtwarzania video
    * @memberof Video
    */
  onQuartileChange () {
    switch (this.state.quartile) {
      case 1:
        this.onVastEvent(&#x27;firstQuartile&#x27;)
        break
      case 2:
        this.onVastEvent(&#x27;midpoint&#x27;)
        break
      case 3:
        this.onVastEvent(&#x27;thirdQuartile&#x27;)
        break
    }
    if (typeof this.props.onQuartileChange &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onQuartileChange(this.state.quartile)
  }

  /**
    * zmiana czasu odtwarzania video w postaci pełnych sekund
    * event onTimeUpdate jest wywoływany przy zmiennych interwałach, co może stanowić problem w niektórych scenariuszach
    * @memberof Video
    */
  onFullSecondChange () {
    this.onVastEvent(&#x27;videoplay&#x27;)
    if (typeof this.props.onQuartileChange &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onFullSecondChange(this.state.seconds)
  }

  /**
    * jeżeli nie zostanie dostarczona dedykowana obsługa zdarzenia &amp;lt;br&gt;
    * kliknięcie w obszar video pauzuje/wznawia odtwarzanie
    * w sytuacji w której zadeklarowano autoodtwarzanie video startuje ono bez dźwięki a kliknięcie włącza/wyłącza dźwięk
    * @memberof Video
    */
  onClick () {
    if (typeof this.props.onClick &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) {
      this.props.onClick()
    } else if (this.props.autoplay) {
      this.toggleVolume()
    } else {
      this.toggle()
    }
  }

  /**
    * zliczenie wszystkich kodów mierzących z wszystkich zestawów dla danego klucza
    * @param {string} eventName - klucz zdarzenia
    * @memberof Video
    */
  onVastEvent (eventName) {
    /**
     * część dostarczonych kodów mierzących zawiera token, który ma zostać zastapiony bieżącym timestampem
     */
    let timestamp &#x3D; Math.round((new Date().getTime()) / 1000)
    let token &#x3D; new RegExp(/((\[|\{|\()*)timestamp((\]|\}|\))*)/gi)

    this.props.vast.forEach(set &#x3D;&gt; {
      if (eventName in set) {
        /**
          * obsługujemy tylko kody mierzące w postaci urla bezwzględnego do grafiki
          */
        let image &#x3D; new Image()
        let url &#x3D; set[eventName]

        if ((token.test(url))) url.replace(token, timestamp)

        /**
          * dodatkowy wymóg adserwera adocean dla kodów mierzących video
          */
        if (url.includes(&#x27;adocean&#x27;)) url +&#x3D; &#x60;|_vtm:${this.state.seconds}/_${timestamp}&#x60;

        image.src &#x3D; url
      }
    })
    if (typeof this.props.onVastEvent &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onVastEvent(eventName)
  }

  toggle () {
    if (this.state.status &#x3D;&#x3D;&#x3D; &#x27;playing&#x27;) {
      this.pause()
    } else {
      this.play()
    }
  }

  play () {
    this.video.play()
  }

  pause () {
    this.video.pause()
  }

  mute () {
    this.setState({ muted: true })
    this.onVastEvent(&#x27;mute&#x27;)
  }

  unmute () {
    this.setState({ muted: false })
    this.onVastEvent(&#x27;unmute&#x27;)
  }

  toggleVolume () {
    if (this.state.muted) {
      this.unmute()
    } else {
      this.mute()
    }
  }

  toggleFullScreen () {
    if (this.video.requestFullScreen) {
      this.video.requestFullScreen()
    } else if (this.video.webkitRequestFullScreen) {
      this.video.webkitRequestFullScreen()
    } else if (this.video.mozRequestFullScreen) {
      this.video.mozRequestFullScreen()
    }
    this.onVastEvent(&#x27;fullscreen&#x27;)
  }

  render () {
    return (
      &amp;lt;div className&#x3D;{classNames(&#x27;videoComponent&#x27;)}&gt;
        {&#x27;gui&#x27; in this.props &amp;amp;&amp;amp; this.props.gui.includes(&#x27;mute&#x27;) &amp;amp;&amp;amp; (
          &amp;lt;button onClick&#x3D;{this.toggleVolume}&gt;
            {this.state.muted &amp;amp;&amp;amp; (
              &amp;lt;svg viewBox&#x3D;&quot;0 0 512 512&quot;&gt;
                &amp;lt;path d&#x3D;&quot;M215.03 71.05L126.06 160H24c-13.26 0-24 10.74-24 24v144c0 13.25 10.74 24 24 24h102.06l88.97 88.95c15.03 15.03 40.97 4.47 40.97-16.97V88.02c0-21.46-25.96-31.98-40.97-16.97zM461.64 256l45.64-45.64c6.3-6.3 6.3-16.52 0-22.82l-22.82-22.82c-6.3-6.3-16.52-6.3-22.82 0L416 210.36l-45.64-45.64c-6.3-6.3-16.52-6.3-22.82 0l-22.82 22.82c-6.3 6.3-6.3 16.52 0 22.82L370.36 256l-45.63 45.63c-6.3 6.3-6.3 16.52 0 22.82l22.82 22.82c6.3 6.3 16.52 6.3 22.82 0L416 301.64l45.64 45.64c6.3 6.3 16.52 6.3 22.82 0l22.82-22.82c6.3-6.3 6.3-16.52 0-22.82L461.64 256z&quot;&gt;&amp;lt;/path&gt;
              &amp;lt;/svg&gt;
            )}
            {!this.state.muted &amp;amp;&amp;amp; (
              &amp;lt;svg viewBox&#x3D;&quot;0 0 480 512&quot;&gt;
                &amp;lt;path d&#x3D;&quot;M215.03 71.05L126.06 160H24c-13.26 0-24 10.74-24 24v144c0 13.25 10.74 24 24 24h102.06l88.97 88.95c15.03 15.03 40.97 4.47 40.97-16.97V88.02c0-21.46-25.96-31.98-40.97-16.97zM480 256c0-63.53-32.06-121.94-85.77-156.24-11.19-7.14-26.03-3.82-33.12 7.46s-3.78 26.21 7.41 33.36C408.27 165.97 432 209.11 432 256s-23.73 90.03-63.48 115.42c-11.19 7.14-14.5 22.07-7.41 33.36 6.51 10.36 21.12 15.14 33.12 7.46C447.94 377.94 480 319.53 480 256zm-141.77-76.87c-11.58-6.33-26.19-2.16-32.61 9.45-6.39 11.61-2.16 26.2 9.45 32.61C327.98 228.28 336 241.63 336 256c0 14.38-8.02 27.72-20.92 34.81-11.61 6.41-15.84 21-9.45 32.61 6.43 11.66 21.05 15.8 32.61 9.45 28.23-15.55 45.77-45 45.77-76.88s-17.54-61.32-45.78-76.86z&quot;&gt;&amp;lt;/path&gt;
              &amp;lt;/svg&gt;
            )}
          &amp;lt;/button&gt;
        )}
        {&#x27;gui&#x27; in this.props &amp;amp;&amp;amp; this.props.gui.includes(&#x27;fullscreen&#x27;) &amp;amp;&amp;amp; (
          &amp;lt;button onClick&#x3D;{this.toggleFullScreen}&gt;
            &amp;lt;svg viewBox&#x3D;&quot;0 0 448 512&quot;&gt;
              &amp;lt;path d&#x3D;&quot;M0 180V56c0-13.3 10.7-24 24-24h124c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12H64v84c0 6.6-5.4 12-12 12H12c-6.6 0-12-5.4-12-12zM288 44v40c0 6.6 5.4 12 12 12h84v84c0 6.6 5.4 12 12 12h40c6.6 0 12-5.4 12-12V56c0-13.3-10.7-24-24-24H300c-6.6 0-12 5.4-12 12zm148 276h-40c-6.6 0-12 5.4-12 12v84h-84c-6.6 0-12 5.4-12 12v40c0 6.6 5.4 12 12 12h124c13.3 0 24-10.7 24-24V332c0-6.6-5.4-12-12-12zM160 468v-40c0-6.6-5.4-12-12-12H64v-84c0-6.6-5.4-12-12-12H12c-6.6 0-12 5.4-12 12v124c0 13.3 10.7 24 24 24h124c6.6 0 12-5.4 12-12z&quot;&gt;&amp;lt;/path&gt;
            &amp;lt;/svg&gt;
          &amp;lt;/button&gt;
        )}
        &amp;lt;video
          ref&#x3D;{c &#x3D;&gt; {
            this.video &#x3D; c
          }}
          onClick&#x3D;{this.onClick}
          autoPlay&#x3D;{this.props.autoplay}
          muted&#x3D;{this.state.muted}
          playsinline
          loop&#x3D;{this.props.loop}
          onPlay&#x3D;{this.onPlay}
          onPause&#x3D;{this.onPause}
          onStop&#x3D;{this.onStop}
          onEnded&#x3D;{this.onEnded}
          onWaiting&#x3D;{this.onWaiting}
          onLoadedData&#x3D;{this.onLoadedData}
          onTimeUpdate&#x3D;{this.onTimeUpdate}
        &gt;
          {&#x27;webm&#x27; in this.props &amp;amp;&amp;amp; (
            &amp;lt;source src&#x3D;{this.props.webm} type&#x3D;&quot;video/webm&quot; /&gt;
          )}
          {&#x27;ogv&#x27; in this.props &amp;amp;&amp;amp; (
            &amp;lt;source src&#x3D;{this.props.ogv} type&#x3D;&quot;video/ogg&quot; /&gt;
          )}
          &amp;lt;source src&#x3D;{this.props.mp4} type&#x3D;&quot;video/mp4&quot; /&gt;
        &amp;lt;/video&gt;
      &amp;lt;/div&gt;
    )
  }
}
</code></pre>
          </article>
        </div>
      </div>
      <nav id="jsdoc-toc-nav" role="navigation"></nav>
    </div>
  </div>
  <footer id="jsdoc-footer" class="jsdoc-footer">
    <div id="jsdoc-footer-container">
      <p>
        Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc</a> 3.6.3 on August 22, 2019.
      </p>
    </div>
  </footer>
  <script src="scripts/jquery.min.js"></script>
  <script src="scripts/jquery.cookie.js"></script>
  <script src="scripts/tree.jquery.js"></script>
  <script src="scripts/prettify.js"></script>
  <script src="scripts/jsdoc-toc.js"></script>
  <script src="scripts/linenumber.js"></script>
  <script src="scripts/scrollanchor.js"></script>
</body>

</html>